<script lang="ts">
import { IsMobileMixin } from '../../../mixins';

interface Section {
  icon: string;
  data: string;
  name: string;
}

interface Card {
  icon: string;
  header: string;
  description: string;
  url: string;
  category: string;
}

export default {
  mixins: [IsMobileMixin],
  props: {
    header: {
      type: String,
      required: true,
    },
    section: {
      type: Array<Section>,
      required: true,
    },
    card: {
      type: Array<Card>,
      required: true,
    },
    disclaimer: {
      type: String,
      required: true,
    },
  },
  data: () => ({
    filtered: [],
    activeCategory: 'developing',
  }),
  created() {
    this.filterFeatures(this.section[0].data);
  },
  methods: {
    filterFeatures(categoryName) {
      const categoryIdentifier = categoryName;
      this.activeCategory = categoryIdentifier;

      this.filtered = this.card.filter(
        (feature) => feature.category === categoryIdentifier,
      );
    },
  },
};
</script>

<template>
  <section class="slp-mt-96">
    <SlpTypography
      class="slp-pb-32 header"
      variant="heading3-bold"
      tag="h2"
      :data-aos="'fade-up'"
      :data-aos-duration="1200"
      :data-aos-offset="200"
    >
      {{ header }}
    </SlpTypography>
    <div class="container">
      <header class="feature-categories">
        <button
          v-for="category in section"
          :key="category.name"
          :class="{ selected: activeCategory === category.data }"
          :data-ga-name="`${category.name.toLowerCase()} tab`"
          data-ga-location="features"
          @click="filterFeatures(category.data)"
        >
          <SlpIcon
            class="icon"
            :name="category.icon"
            variant="marketing"
            size="md"
            color="white"
          />
          {{ category.name }}
        </button>
      </header>
      <div class="feature-cards">
        <a
          v-for="item in filtered"
          :key="item.header"
          class="feature-card"
          :data-category="item.category"
          :data-aos="'fade-up'"
          :data-aos-duration="1200"
          :data-aos-offset="200"
          :href="item.url"
          :data-ga-name="item.header.toLowerCase()"
          data-ga-location="body"
        >
          <SlpIcon
            class="card-icon"
            :name="item.icon"
            variant="marketing"
            color="white"
            size="md"
          />
          <SlpTypography class="slp-pt-16" variant="body1-bold" tag="h3">
            {{ item.header }}
          </SlpTypography>
          <SlpTypography
            class="feature-card__text slp-py-8"
            variant="body-2"
            tag="p"
          >
            {{ item.description }}
          </SlpTypography>
          <div class="feature-card__cta">
            {{ item.text || 'Read more' }}
            <SlpIcon name="chevron-lg-right" variant="product" />
          </div>
        </a>
      </div>
    </div>
    <div class="disclaimer slp-mt-32" v-html="$md.render(disclaimer)" />
  </section>
</template>

<style lang="scss" scoped>
* {
  color: white;
}

.header {
  max-width: 750px;
}

.container {
  background: linear-gradient(
    0deg,
    rgba(225, 152, 109, 0.1) 0%,
    rgba(110, 67, 211, 0.1) 100%
  );
  border: 1px solid #45424d;
  padding: 32px;
  border-radius: 8px;
}

.feature-categories {
  display: flex;
  justify-content: center;

  @media screen and (max-width: 768px) {
    flex-direction: column;
  }
}

.disclaimer {
  color: #a2a1a6;
  font-size: 14px;
  font-weight: 400;
  line-height: 22px;
}
.feature-cards {
  padding-top: 32px;
  display: grid;
  gap: 32px;
  grid-template-columns: 1fr 1fr;
  align-items: stretch;

  @media screen and (max-width: 768px) {
    grid-template-columns: 1fr;
  }
}

@keyframes hover-animation {
  0% {
    border-radius: 8px 8px 8px 8px;
  }
  100% {
    border-radius: 8px 8px 80px 8px;
  }
}

@keyframes hover-off-animation {
  0% {
    border-radius: 8px 8px 80px 8px;
  }
  100% {
    border-radius: 8px 8px 8px 8px;
  }
}

.feature-card:hover {
  animation: hover-animation 0.3s ease forwards;
}

.feature-card:not(:hover) {
  animation: hover-off-animation 0.3s ease forwards;
}

.feature-card {
  background: #171321;
  border-radius: 8px 8px 8px 8px;
  padding: 24px;
  display: flex;
  flex-direction: column;
  transition: all 0.2s ease-in-out;

  &:hover {
    .slp-icon {
      margin-left: 8px;
    }
  }
}

.card-icon {
  width: 34px;
  height: 34px;
}

.feature-card__text {
  color: #a2a1a6;
  flex-grow: 1;
}

.feature-card__cta {
  display: inline-flex;
  color: white;
  font-size: 18px;
  line-height: 20px;
  font-weight: $font-weight-bold;
  align-items: center;
  padding: 11px 0;
}

.slp-icon {
  margin-left: 4px;
  transition: margin-left 0.2s ease-in-out;
}

button {
  color: #a2a1a6;
  padding: $spacing-24 $spacing-32;
  font-size: 16px;
  font-weight: 600;
  line-height: 24px;
  text-align: center;
  cursor: pointer;
  border: none;
  border-bottom: 1px solid #45424d;
  transition:
    color 0.3s ease,
    border-bottom-color 0.3s ease;

  box-shadow: 0 3px 0 0 transparent;
  display: flex;
  flex-direction: column;
  align-items: center;
  gap: 8px;

  &:hover,
  &:focus {
    color: white;
  }
}

.selected {
  box-shadow: 0 2px 0 0 #7759c2;
  color: white;
}
</style>
